diff --git a/daemon/execdriver/zones/driver.go b/daemon/execdriver/zones/driver.go
new file mode 100644
index 0000000..db48175
--- /dev/null
+++ b/daemon/execdriver/zones/driver.go
@@ -0,0 +1,799 @@
+// +build solaris,cgo
+
+package zones
+
+import (
+	"bufio"
+	"bytes"
+	"encoding/json"
+	"errors"
+	"fmt"
+	"io"
+	"io/ioutil"
+	"os"
+	"os/exec"
+	"path/filepath"
+	"strconv"
+	"strings"
+	"sync"
+	"syscall"
+
+	"github.com/Sirupsen/logrus"
+	"github.com/docker/docker/daemon/execdriver"
+	"github.com/opencontainers/runc/libcontainer"
+)
+
+/*
+
+#cgo LDFLAGS: -lcontract
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <string.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <limits.h>
+
+#include <sys/ctfs.h>
+#include <sys/contract/process.h>
+#include <libcontract.h>
+
+// create contract template for runz
+int ct_pr_tmpl(void)
+{
+	int ctfd, err;
+
+	// Open process contract template.
+	ctfd = open64(CTFS_ROOT "/process/template", O_RDWR | O_CLOEXEC);
+	if (ctfd == -1) {
+		return (-1);
+	}
+	if ((err = ct_pr_tmpl_set_param(ctfd, CT_PR_PGRPONLY | CT_PR_REGENT)) != 0) {
+		goto out;
+	}
+	err = ct_tmpl_activate(ctfd);
+
+out:
+	if (err != 0) {
+		(void) close(ctfd);
+		ctfd = -1;
+		errno = err;
+	}
+
+	return (ctfd);
+}
+
+int ct_clear(int ctfd)
+{
+	int err;
+
+	err = ct_tmpl_clear(ctfd);
+	(void) close(ctfd);
+
+	return (err);
+}
+
+int ct_abandon_latest(void)
+{
+	int ctfd, err, ctid, n;
+	char path[PATH_MAX];
+
+	if ((err = contract_latest(CT_TYPE_PROCESS, &ctid)) != 0) {
+		return (err);
+	}
+	n = snprintf(path, sizeof(path), CTFS_ROOT "/all/%d/ctl", ctid);
+	if (n >= sizeof(path)) {
+		return (ENAMETOOLONG);
+	}
+	ctfd = open64(path, O_WRONLY | O_CLOEXEC);
+	if (ctfd == -1) {
+		return (errno);
+	}
+	err = ct_ctl_abandon(ctfd);
+
+	return (err);
+}
+*/
+import "C"
+
+const (
+	DriverName          = "zones"
+	Version             = "0.1"
+	RUNZ                = "/usr/lib/brand/solaris-oci/runz"
+	DUMMY_PID           = 0
+	EXEC_PATH           = "/system/volatile"
+	LX_DOCKER_INIT_PATH = "/usr/lib/brand/lx/lx_docker_init"
+	SVCCFG              = "/usr/sbin/svccfg"
+)
+
+// We don't yet have libcontainer.Factory support, so just whack it together here
+type containerInit struct {
+	Name     string
+	Brand    string
+	Zonepath string
+}
+
+type activeContainer struct {
+	command *execdriver.Command
+}
+
+type Driver struct {
+	root             string
+	activeContainers map[string]*activeContainer
+	sync.Mutex
+}
+
+type info struct {
+	ID     string
+	driver *Driver
+}
+
+/* Structs for compiling json to pass to RunZ */
+
+type RunzConfig struct {
+	Solaris    `json:"solaris"`
+	Hostname   string `json:"hostname"`
+	Platform   `json:"platform"`
+	Process    `json:"process"`
+	RootSpec   `json:"root"`
+	OciVersion string `json:"ociVersion"`
+}
+
+type CappedCpu struct {
+	Ncpus string `json:"ncpus,omitempty"`
+}
+type CappedMemory struct {
+	Physical string `json:"physical,omitempty"`
+	Swap     string `json:"swap,omitempty"`
+}
+
+type Solaris struct {
+	CpuShare     string       `json:"cpuShares,omitempty"`
+	MaxShmMemory string       `json:"maxShmMemory,omitempty"`
+	RunzAnet     []*RunzAnet  `json:"anet,omitempty"`
+	CappedCpu    CappedCpu    `json:"cappedCPU,omitempty"`
+	CappedMemory CappedMemory `json:"cappedMemory,omitempty"`
+	LimitPriv    string       `json:"limitpriv,omitempty"`
+	Milestone    string       `json:"milestone,omitempty"`
+}
+
+type Platform struct {
+	Arch   string `json:"arch"`
+	Ostype string `json:"os"`
+}
+
+type Process struct {
+	Args     []string `json:"args"`
+	Cwd      string   `json:"cwd"`
+	Env      []string `json:"env"`
+	Terminal bool     `json:"terminal"`
+	User     `json:"user"`
+}
+
+type RootSpec struct {
+	Path     string `json:"path"`
+	Readonly bool   `json:"readonly"`
+}
+
+type RunzAnet struct {
+	Linkname          string `json:"linkname,omitempty"`
+	Lowerlink         string `json:"lowerLink,omitempty"`
+	Allowedaddr       string `json:"allowedAddress,omitempty"`
+	Configallowedaddr string `json:"configureAllowedAddress,omitempty"`
+	Defrouter         string `json:"defrouter,omitempty"`
+	Linkprotection    string `json:"linkProtection,omitempty"`
+	Macaddress        string `json:"macAddress,omitempty"`
+}
+
+type User struct {
+	AdditionalGids []int64 `json:"additionalGids,omitempty"`
+	Gid            int64   `json:"gid"`
+	Uid            int64   `json:"uid"`
+}
+
+func startWrapper(cmd *exec.Cmd) error {
+	// create processes in their own process contracts
+	var cttmpl C.int
+	var err error
+
+	if cttmpl, err = C.ct_pr_tmpl(); cttmpl == -1 {
+		return err
+	}
+	defer func() {
+		if errn := C.ct_abandon_latest(); errn != 0 {
+			logrus.Error("Failed to abandon process contract: ", C.GoString(C.strerror(errn)))
+		}
+		if errn := C.ct_clear(cttmpl); errn != 0 {
+			logrus.Error("Failed to clear process contract template ", C.GoString(C.strerror(errn)))
+		}
+	}()
+	err = cmd.Start()
+
+	return err
+}
+
+func NewDriver(root string, options []string) (*Driver, error) {
+	if err := os.MkdirAll(root, 0700); err != nil {
+		return nil, err
+	}
+
+	return &Driver{
+		root:             root,
+		activeContainers: make(map[string]*activeContainer),
+	}, nil
+}
+
+func getEnv(key string, env []string) string {
+	for _, pair := range env {
+		parts := strings.SplitN(pair, "=", 2)
+		if parts[0] == key {
+			return parts[1]
+		}
+	}
+	return ""
+}
+
+func (d *Driver) Exec(c *execdriver.Command, processConfig *execdriver.ProcessConfig, pipes *execdriver.Pipes, hooks execdriver.Hooks) (int, error) {
+
+	args := []string{processConfig.Entrypoint}
+	args = append(args, processConfig.Arguments...)
+	hostname := getEnv("HOSTNAME", c.ProcessConfig.Env)
+	if hostname == "" {
+		hostname = c.Name
+	}
+
+	var userID int
+	var groupID int
+	var err error
+	if c.ProcessConfig.User != "" {
+		ids := strings.Split(c.ProcessConfig.User, ":")
+		userID, err = strconv.Atoi(ids[0])
+		if err != nil {
+			logrus.Error("Only uid[:gid] is supported")
+			return -1, err
+		}
+		if len(ids) == 1 {
+			groupID = 0
+		} else {
+			groupID, err = strconv.Atoi(ids[1])
+			if err != nil {
+				logrus.Error("Only uid[:gid] is supported")
+				return -1, err
+			}
+		}
+	} else {
+		userID = 0
+		groupID = 0
+	}
+
+	env := processConfig.Env
+	if env == nil {
+		env = c.ProcessConfig.Env
+	}
+
+	ProcessPath := filepath.Join(EXEC_PATH, c.ID[0:12], "process.json")
+	if err := os.MkdirAll(filepath.Dir(ProcessPath), 0644); err != nil {
+		return -1, err
+	}
+	processconfig := Process{
+		Args:     args,
+		Cwd:      c.WorkingDir,
+		Env:      env,
+		Terminal: processConfig.Tty,
+		User: User{
+			Gid: int64(groupID),
+			Uid: int64(userID),
+		},
+	}
+
+	fileJson, _ := json.Marshal(processconfig)
+	if err := ioutil.WriteFile(ProcessPath, fileJson, 0644); err != nil {
+		return -1, err
+	}
+
+	cmd := exec.Command(RUNZ, "exec", "-p", ProcessPath, c.Name)
+	cmd.Dir = filepath.Dir(filepath.Dir(c.Rootfs))
+	cmd.Stdout = pipes.Stdout
+	cmd.Stderr = pipes.Stderr
+	r, w, err := os.Pipe()
+	if err != nil {
+		return -1, err
+	}
+
+	if pipes.Stdin != nil {
+		go func() {
+			io.Copy(w, pipes.Stdin)
+			w.Close()
+		}()
+		cmd.Stdin = r
+	}
+
+	/*
+		We do not have a way to pass in a console to runz right now.
+		If and when we do decide to have that we will need to implement
+		fully the Terminal interface of execdriver and the Console interface
+		of libcontainer. Until then we make do with this stub.
+	*/
+	var term execdriver.Terminal
+	if processConfig.Tty {
+		term = &TtyConsole{
+			console: nil,
+		}
+	} else {
+		term, err = execdriver.NewStdConsole(processConfig, pipes)
+	}
+	processConfig.Terminal = term
+
+	if err = startWrapper(cmd); err != nil {
+		logrus.Errorf("%v: failed to exec start: %v", c.Name, err)
+		return -1, err
+	}
+
+	// TODO solaris: other exec drivers use pid, even if wrapped in another exec framework
+	// (e.g. windows, freebsd). possible we should be saving off pid of runz here? For now
+	// we use a dummy pid.
+	// TODO: USE runz state and get pid
+	if hooks.Start != nil {
+		// A closed channel for OOM is returned here as it will be
+		// non-blocking and return the correct result when read.
+		chOOM := make(chan struct{})
+		close(chOOM)
+		hooks.Start(processConfig, DUMMY_PID, chOOM)
+	}
+
+	if err = cmd.Wait(); err != nil {
+		logrus.Errorf("%v: failed to exec: %v", c.Name, err)
+		if strings.Contains(err.Error(), "signal: killed") {
+			fmt.Printf("Calling \"runz stop\" from exec\n")
+			d.Kill(c, 9)
+		}
+		return -1, err
+	}
+
+	return 0, nil
+}
+
+// TODO solaris: this should be refactored for new volume support
+func setupMounts(mounts []execdriver.Mount, rootfs string) error {
+	for _, m := range mounts {
+		if _, err := os.Stat(filepath.Join(rootfs, m.Destination)); err != nil {
+			if !os.IsNotExist(err) {
+				return err
+			}
+			if err := os.MkdirAll(filepath.Join(rootfs, m.Destination), 0755); err != nil {
+				return err
+			}
+		}
+		cmd := exec.Command("/usr/sbin/mount", "-F", "lofs", m.Source, filepath.Join(rootfs, m.Destination))
+		errBuf := new(bytes.Buffer)
+		cmd.Stderr = errBuf
+		if err := cmd.Run(); err != nil {
+			return fmt.Errorf("Failed to mount: %s", errBuf)
+		}
+	}
+	return nil
+}
+
+// TODO solaris: this should be refactored for new volume support
+func destroyMounts(mounts []execdriver.Mount, rootfs string) error {
+	/*
+	   This is a no-op currently because the zones framework unmounts
+	   all the mountpoints from within the container while shutting
+	   down.
+	*/
+	return nil
+}
+
+func setStringFloat(val float64) string {
+	if val == 0 {
+		return ""
+	}
+	return strconv.FormatFloat(val, 'f', 2, 64)
+}
+func setStringVal(val int64) string {
+	if val == 0 {
+		return ""
+	}
+	return strconv.FormatInt(val, 10)
+}
+
+// Run implements the exec driver Driver interface,
+// it calls libcontainer APIs to run a container.
+func (d *Driver) Run(c *execdriver.Command, pipes *execdriver.Pipes, hooks execdriver.Hooks) (execdriver.ExitStatus, error) {
+
+	args := []string{c.ProcessConfig.Entrypoint}
+	args = append(args, c.ProcessConfig.Arguments...)
+	hostname := getEnv("HOSTNAME", c.ProcessConfig.Env)
+	if hostname == "" {
+		hostname = c.Name
+	}
+	fmt.Printf("The hostname of the container is: %+v\n", hostname)
+	fmt.Printf("The name of the container is: %+v\n", c.Name)
+	fmt.Printf("user spec is : %+v\n", c.ProcessConfig.User)
+	var OStype string
+	if c.ContOS == "solaris" {
+		OStype = "SunOS"
+	} else {
+		OStype = "Linux"
+		cmd := exec.Command(LX_DOCKER_INIT_PATH, c.Rootfs)
+		if err := cmd.Run(); err != nil {
+			fmt.Printf("lx init failed\n")
+			return execdriver.ExitStatus{ExitCode: -1}, err
+		}
+	}
+
+	var userID int
+	var groupID int
+	var err error
+	if c.ProcessConfig.User != "" {
+		ids := strings.Split(c.ProcessConfig.User, ":")
+		userID, err = strconv.Atoi(ids[0])
+		if err != nil {
+			logrus.Error("Only uid[:gid] is supported")
+			return execdriver.ExitStatus{ExitCode: -1}, err
+		}
+		if len(ids) == 1 {
+			groupID = 0
+		} else {
+			groupID, err = strconv.Atoi(ids[1])
+			if err != nil {
+				logrus.Error("Only uid[:gid] is supported")
+				return execdriver.ExitStatus{ExitCode: -1}, err
+			}
+		}
+	} else {
+		userID = 0
+		groupID = 0
+	}
+
+	// TODO solaris: should this be handled by volumes?
+	setupMounts(c.Mounts, c.Rootfs)
+	logrus.Infof("Container cmd mounts: %+v\n", c.Mounts)
+
+	// since we've futzed with the mount, c.Rootfs gets set to the 'root' as well.
+	// Hack this via Dir(Dir()) to get to the container base fs, rather than the zoneroot.
+	ConfigPath := filepath.Join(filepath.Dir(filepath.Dir(c.Rootfs)), "config.json")
+
+	logrus.Infof("OCI Configuration: [%s]", ConfigPath)
+
+	var anets []*RunzAnet
+	if c.Network.Interface != nil && c.Network.Interface.IPAddress != "" {
+		lowerlink := ""
+		if c.Network.Interface.Bridge != "" {
+			lowerlink = c.Network.Interface.Bridge
+		} else {
+			lowerlink = "auto"
+		}
+		runzanet := &RunzAnet{
+			Linkname:          "net0",
+			Lowerlink:         lowerlink,
+			Allowedaddr:       c.Network.Interface.IPAddress,
+			Configallowedaddr: "true",
+			Defrouter:         c.Network.Interface.Defrouter,
+			Linkprotection:    "mac-nospoof, ip-nospoof",
+			Macaddress:        c.Network.Interface.MacAddress,
+		}
+		anets = append(anets, runzanet)
+	}
+
+	var cont_milestone string
+	if anets == nil {
+		cont_milestone = ""
+	} else {
+		cont_milestone = "svc:/milestone/container:default"
+	}
+
+	var ncpus float64
+	if c.Resources.CPUQuota > 0 {
+		/*
+		 * c.Resources.CPUQuota = 50000 => 50% of cpu
+		 * which 0.5 ncpus
+		 */
+		ncpus = (float64(c.Resources.CPUQuota) / 100000)
+	}
+
+	if _, err := os.Stat(ConfigPath); os.IsNotExist(err) {
+		runzconfig := RunzConfig{
+			Solaris: Solaris{
+				RunzAnet: anets,
+				CappedMemory: CappedMemory{
+					Physical: setStringVal(c.Resources.Memory),
+					Swap:     setStringVal(c.Resources.MemorySwap),
+				},
+				CappedCpu: CappedCpu{
+					Ncpus: setStringFloat(ncpus),
+				},
+				CpuShare:     setStringVal(c.Resources.CPUShares),
+				MaxShmMemory: setStringVal(*c.ShmSize),
+				LimitPriv:    c.LimitPriv,
+				Milestone:    cont_milestone,
+			},
+			Hostname: hostname,
+			Platform: Platform{
+				c.Arch,
+				OStype,
+			},
+			Process: Process{
+				Args:     args,
+				Cwd:      c.WorkingDir,
+				Env:      c.ProcessConfig.Env,
+				Terminal: c.ProcessConfig.Tty,
+				User: User{
+					Gid: int64(groupID),
+					Uid: int64(userID),
+				},
+			},
+			RootSpec: RootSpec{
+				Path:     "rootfs",
+				Readonly: c.ReadonlyRootfs,
+			},
+			OciVersion: "0.6.0",
+		}
+
+		fileJson, _ := json.Marshal(runzconfig)
+		if err = ioutil.WriteFile(ConfigPath, fileJson, 0644); err != nil {
+			return execdriver.ExitStatus{ExitCode: -1}, err
+		}
+	}
+
+	defer func() {
+		if err := exec.Command(RUNZ, "delete", c.Name).Run(); err != nil {
+			logrus.Errorf("failed to delete container %v: %v", c.Name, err)
+		}
+	}()
+
+	ProfilesPath := filepath.Join(filepath.Dir(filepath.Dir(c.Rootfs)), "/.svc_bundle")
+	if err = os.Mkdir(ProfilesPath, 0700); err != nil {
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	PathDnsXml := filepath.Join(ProfilesPath, "/dns_client.xml")
+	PathNSSwitchXml := filepath.Join(ProfilesPath, "/ns_switch.xml")
+
+	err = exec.Command(SVCCFG, "extract", "dns/client", ">", PathDnsXml).Run()
+	if err != nil {
+		logrus.Errorf("Error exporting dns/client: %v", err)
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	cmd := exec.Command(SVCCFG, "-s", "svc:/network/dns/client:default", "listprop", "general/enabled")
+	outbufgen := new(bytes.Buffer)
+	cmd.Stdout = outbufgen
+	if err = cmd.Run(); err != nil {
+		logrus.Errorf("Error listing property: %s", err)
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	cmd = exec.Command(SVCCFG, "-s", "svc:/network/dns/client:default", "listprop", "general_ovr/enabled")
+	outbufgenovr := new(bytes.Buffer)
+	cmd.Stdout = outbufgenovr
+	if err = cmd.Run(); err != nil {
+		logrus.Errorf("Error listing property: %s", err)
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	if strings.Contains(outbufgen.String(), "false") && strings.Contains(outbufgenovr.String(), "true") {
+		PathDnsOvrXml := filepath.Join(ProfilesPath, "/dns_ovr_client.xml")
+		var f *os.File
+		FoundDnsClient := false
+
+		if f, err = os.Open(PathDnsXml); err != nil {
+			logrus.Errorf("Error opening file: %v", err)
+			return execdriver.ExitStatus{ExitCode: -1}, err
+		}
+		scanner := bufio.NewScanner(f)
+
+		if f, err = os.Create(PathDnsOvrXml); err != nil {
+			logrus.Errorf("Error creating file: %v", err)
+			return execdriver.ExitStatus{ExitCode: -1}, err
+		}
+		wr := bufio.NewWriter(f)
+
+		for scanner.Scan() {
+			line := scanner.Text()
+			if strings.Contains(line, "network/dns/client") {
+				FoundDnsClient = true
+			}
+			if (strings.Contains(line, "<instance name=\"default\"") || strings.Contains(line, "<create_default_instance")) && FoundDnsClient == true {
+				if strings.Contains(line, "enabled") {
+					src := bytes.Replace([]byte(line), []byte("false"), []byte("true"), -1)
+					line = string(src[:])
+				}
+				FoundDnsClient = false
+			}
+			wr.WriteString(line)
+			wr.Flush()
+		}
+		os.Remove(PathDnsXml)
+	}
+
+	err = exec.Command(SVCCFG, "extract", "name-service/switch", ">", PathNSSwitchXml).Run()
+	if err != nil {
+		logrus.Errorf("Error exporting name-service/switch: %v", err)
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	cmd = exec.Command(RUNZ, "run", c.Name, filepath.Dir(filepath.Dir(c.Rootfs)))
+	cmd.Dir = filepath.Dir(filepath.Dir(c.Rootfs))
+	cmd.Stdout = pipes.Stdout
+	cmd.Stderr = pipes.Stderr
+	r, w, err := os.Pipe()
+	if err != nil {
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	if pipes.Stdin != nil {
+		go func() {
+			io.Copy(w, pipes.Stdin)
+			w.Close()
+		}()
+		cmd.Stdin = r
+	}
+
+	/*
+		We do not have a way to pass in a console to runz right now.
+		If and when we do decide to have that we will need to implement
+		fully the Terminal interface of execdriver and the Console interface
+		of libcontainer. Until then we make do with this stub.
+	*/
+	var term execdriver.Terminal
+	if c.ProcessConfig.Tty {
+		term = &TtyConsole{
+			console: nil,
+		}
+	} else {
+		term, err = execdriver.NewStdConsole(&c.ProcessConfig, pipes)
+	}
+	c.ProcessConfig.Terminal = term
+
+	if err = startWrapper(cmd); err != nil {
+		logrus.Errorf("%v: failed to exec start: %v", c.Name, err)
+		return execdriver.ExitStatus{ExitCode: -1}, err
+	}
+
+	// TODO solaris: other exec drivers use pid, even if wrapped in another exec framework
+	// (e.g. windows, freebsd). possible we should be saving off pid of runz here? For now
+	// we use a dummy pid.
+	// TODO: USE runz state and get pid
+	if hooks.Start != nil {
+		// A closed channel for OOM is returned here as it will be
+		// non-blocking and return the correct result when read.
+		chOOM := make(chan struct{})
+		close(chOOM)
+		hooks.Start(&c.ProcessConfig, DUMMY_PID, chOOM)
+	}
+	d.Lock()
+	d.activeContainers[c.ID] = &activeContainer{
+		command: c,
+	}
+	d.Unlock()
+	defer func() {
+		d.Lock()
+		delete(d.activeContainers, c.ID)
+		d.Unlock()
+	}()
+
+	if err = cmd.Wait(); err != nil {
+		logrus.Errorf("%v: failed to start: %v", c.Name, err)
+		if strings.Contains(err.Error(), "signal: killed") {
+			fmt.Printf("Calling \"runz stop\" from run\n")
+			d.Kill(c, 9)
+		}
+		var status int
+		if msg, ok := err.(*exec.ExitError); ok { // there is error code
+			status = msg.Sys().(syscall.WaitStatus).ExitStatus()
+		} else {
+			status = -1
+		}
+		return execdriver.ExitStatus{ExitCode: status}, err
+	}
+
+	if c.Mounts != nil {
+		if err := destroyMounts(c.Mounts, c.Rootfs); err != nil {
+			logrus.Errorf("%v: failed to unmount: %v", c.Name, err)
+			return execdriver.ExitStatus{ExitCode: -1}, err
+		}
+	}
+
+	return execdriver.ExitStatus{ExitCode: 0}, nil
+}
+
+// Kill implements the exec driver Driver interface.
+func (d *Driver) Kill(c *execdriver.Command, sig int) error {
+
+	cmd := exec.Command(RUNZ, "kill", c.Name, strconv.Itoa(sig))
+	cmd.Dir = filepath.Dir(filepath.Dir(c.Rootfs))
+
+	outbuf := new(bytes.Buffer)
+	errbuf := new(bytes.Buffer)
+
+	cmd.Stdout = outbuf
+	cmd.Stderr = errbuf
+	defer func() {
+		d.Lock()
+		delete(d.activeContainers, c.ID)
+		d.Unlock()
+	}()
+	if err := startWrapper(cmd); err != nil {
+		logrus.Errorf("%v: failed to exec kill: %v", c.Name, err)
+		return err
+	}
+	if err := cmd.Wait(); err != nil {
+		logrus.Errorf("%v: failed to wait kill: %+v %+v", c.Name, outbuf.String(), errbuf.String())
+		return fmt.Errorf("%+v %+v\n", outbuf.String(), errbuf.String())
+	}
+
+	return nil
+}
+
+// Pause implements the exec driver Driver interface,
+// it calls libcontainer API to pause a container.
+func (d *Driver) Pause(c *execdriver.Command) error {
+	return errors.New("Pause is not supported in zones execdriver")
+}
+
+// Unpause implements the exec driver Driver interface,
+// it calls libcontainer API to unpause a container.
+func (d *Driver) Unpause(c *execdriver.Command) error {
+	return errors.New("Unpause is not supported in zones execdriver")
+}
+
+// Terminate implements the exec driver Driver interface.
+func (d *Driver) Terminate(c *execdriver.Command) error {
+	return errors.New("Terminate is not supported in zones execdriver")
+}
+
+func (d *Driver) IsRunning() bool {
+	return false
+}
+
+func (d *Driver) Info(id string) execdriver.Info {
+	return nil
+}
+
+// Name implements the exec driver Driver interface.
+func (d *Driver) Name() string {
+	return fmt.Sprintf("%s-%s", DriverName, Version)
+}
+
+// GetPidsForContainer implements the exec driver Driver interface.
+func (d *Driver) GetPidsForContainer(id string) ([]int, error) {
+	return nil, errors.New("GetPidsForContainer is not supported in zones execdriver")
+}
+
+// Clean implements the exec driver Driver interface.
+func (d *Driver) Clean(id string) error {
+	return os.RemoveAll(filepath.Join(d.root, id))
+}
+
+// Stats implements the exec driver Driver interface.
+func (d *Driver) Stats(id string) (*execdriver.ResourceStats, error) {
+	return nil, errors.New("Stats is not supported in zones execdriver")
+}
+
+// Stats implements the exec driver Driver interface.
+func (d *Driver) Update(c *execdriver.Command) error {
+	return errors.New("Update is not supported in zones execdriver")
+}
+
+// TtyConsole implements the exec driver Terminal interface
+type TtyConsole struct {
+	console libcontainer.Console
+}
+
+//Resize implements Resize method of Terminal interface
+func (t *TtyConsole) Resize(h, w int) error {
+	return nil
+}
+
+//Close implements Close method of Terminal interface
+func (t *TtyConsole) Close() error {
+	return nil
+}
+
+// SupportsHooks implements the execdriver Driver interface.
+// solaris: TODO  for now false
+func (d *Driver) SupportsHooks() bool {
+	return false
+}
diff --git a/daemon/execdriver/zones/driver_unsupported.go b/daemon/execdriver/zones/driver_unsupported.go
new file mode 100644
index 0000000..8b4a636
--- /dev/null
+++ b/daemon/execdriver/zones/driver_unsupported.go
@@ -0,0 +1,12 @@
+// +build !solaris
+
+package zones
+
+import (
+	"fmt"
+	"github.com/docker/docker/daemon/execdriver"
+)
+
+func NewDriver(root, initPath string) (execdriver.Driver, error) {
+	return nil, fmt.Errorf("zones driver only supported on Solaris")
+}
diff --git a/daemon/execdriver/zones/driver_unsupported_nocgo.go b/daemon/execdriver/zones/driver_unsupported_nocgo.go
new file mode 100644
index 0000000..0b80a10
--- /dev/null
+++ b/daemon/execdriver/zones/driver_unsupported_nocgo.go
@@ -0,0 +1,13 @@
+// +build solaris,!cgo
+
+package zones
+
+import (
+	"fmt"
+	"github.com/docker/docker/daemon/execdriver"
+)
+
+// NewDriver returns a new native driver, called from NewDriver of execdriver.
+func NewDriver(root, initPath string) (execdriver.Driver, error) {
+	return nil, fmt.Errorf("zones driver requires cgo support")
+}
diff --git a/daemon/graphdriver/driver_solaris.go b/daemon/graphdriver/driver_solaris.go
new file mode 100644
index 0000000..be4eb52
--- /dev/null
+++ b/daemon/graphdriver/driver_solaris.go
@@ -0,0 +1,8 @@
+package graphdriver
+
+var (
+	// Slice of drivers that should be used in an order
+	priority = []string{
+		"zfs",
+	}
+)
diff --git a/daemon/graphdriver/driver_unsupported.go b/daemon/graphdriver/driver_unsupported.go
index b3f6857..4a87560 100644
--- a/daemon/graphdriver/driver_unsupported.go
+++ b/daemon/graphdriver/driver_unsupported.go
@@ -1,4 +1,4 @@
-// +build !linux,!windows,!freebsd
+// +build !linux,!windows,!freebsd,!solaris
 
 package graphdriver
 
diff --git a/daemon/graphdriver/graphtest/graphtest_unix.go b/daemon/graphdriver/graphtest/graphtest_unix.go
index 534f2e5..c3e2b35 100644
--- a/daemon/graphdriver/graphtest/graphtest_unix.go
+++ b/daemon/graphdriver/graphtest/graphtest_unix.go
@@ -1,4 +1,4 @@
-// +build linux freebsd
+// +build linux freebsd solaris
 
 package graphtest
 
diff --git a/daemon/graphdriver/register/register_zfs.go b/daemon/graphdriver/register/register_zfs.go
index 8c31c41..3ba59f5 100644
--- a/daemon/graphdriver/register/register_zfs.go
+++ b/daemon/graphdriver/register/register_zfs.go
@@ -1,4 +1,4 @@
-// +build !exclude_graphdriver_zfs,linux !exclude_graphdriver_zfs,freebsd
+// +build !exclude_graphdriver_zfs,linux !exclude_graphdriver_zfs,freebsd solaris
 
 package register
 
diff --git a/daemon/graphdriver/zfs/zfs.go b/daemon/graphdriver/zfs/zfs.go
index 5cc10d2..04e474e 100644
--- a/daemon/graphdriver/zfs/zfs.go
+++ b/daemon/graphdriver/zfs/zfs.go
@@ -1,4 +1,4 @@
-// +build linux freebsd
+// +build linux freebsd solaris
 
 package zfs
 
@@ -7,7 +7,6 @@ import (
 	"os"
 	"os/exec"
 	"path"
-	"strconv"
 	"strings"
 	"sync"
 	"syscall"
@@ -39,10 +38,16 @@ func (*Logger) Log(cmd []string) {
 	logrus.Debugf("[zfs] %s", strings.Join(cmd, " "))
 }
 
+func timeTrack(start time.Time, name string) {
+	elapsed := time.Since(start)
+	fmt.Printf("%s took %s time\n", name, elapsed)
+}
+
 // Init returns a new ZFS driver.
 // It takes base mount path and a array of options which are represented as key value pairs.
 // Each option is in the for key=value. 'zfs.fsname' is expected to be a valid key in the options.
 func Init(base string, opt []string, uidMaps, gidMaps []idtools.IDMap) (graphdriver.Driver, error) {
+	defer timeTrack(time.Now(), "ZFS driver init")
 	var err error
 
 	if _, err := exec.LookPath("zfs"); err != nil {
@@ -172,39 +177,6 @@ func (d *Driver) Cleanup() error {
 	return nil
 }
 
-// Status returns information about the ZFS filesystem. It returns a two dimensional array of information
-// such as pool name, dataset name, disk usage, parent quota and compression used.
-// Currently it return 'Zpool', 'Zpool Health', 'Parent Dataset', 'Space Used By Parent',
-// 'Space Available', 'Parent Quota' and 'Compression'.
-func (d *Driver) Status() [][2]string {
-	parts := strings.Split(d.dataset.Name, "/")
-	pool, err := zfs.GetZpool(parts[0])
-
-	var poolName, poolHealth string
-	if err == nil {
-		poolName = pool.Name
-		poolHealth = pool.Health
-	} else {
-		poolName = fmt.Sprintf("error while getting pool information %v", err)
-		poolHealth = "not available"
-	}
-
-	quota := "no"
-	if d.dataset.Quota != 0 {
-		quota = strconv.FormatUint(d.dataset.Quota, 10)
-	}
-
-	return [][2]string{
-		{"Zpool", poolName},
-		{"Zpool Health", poolHealth},
-		{"Parent Dataset", d.dataset.Name},
-		{"Space Used By Parent", strconv.FormatUint(d.dataset.Used, 10)},
-		{"Space Available", strconv.FormatUint(d.dataset.Avail, 10)},
-		{"Parent Quota", quota},
-		{"Compression", d.dataset.Compression},
-	}
-}
-
 // GetMetadata returns image/container metadata related to graph driver
 func (d *Driver) GetMetadata(id string) (map[string]string, error) {
 	return nil, nil
@@ -218,7 +190,7 @@ func (d *Driver) cloneFilesystem(name, parentName string) error {
 		return err
 	}
 
-	_, err = snapshot.Clone(name, map[string]string{"mountpoint": "legacy"})
+	_, err = snapshot.Clone(name, mountOptions)
 	if err == nil {
 		d.Lock()
 		d.filesystemsCache[name] = true
@@ -267,8 +239,7 @@ func (d *Driver) Create(id string, parent string, mountLabel string) error {
 func (d *Driver) create(id, parent string) error {
 	name := d.zfsPath(id)
 	if parent == "" {
-		mountoptions := map[string]string{"mountpoint": "legacy"}
-		fs, err := zfs.CreateFilesystem(name, mountoptions)
+		fs, err := zfs.CreateFilesystem(name, mountOptions)
 		if err == nil {
 			d.Lock()
 			d.filesystemsCache[fs.Name] = true
diff --git a/daemon/graphdriver/zfs/zfs_freebsd.go b/daemon/graphdriver/zfs/zfs_freebsd.go
index 1c05fa7..24bbfe9 100644
--- a/daemon/graphdriver/zfs/zfs_freebsd.go
+++ b/daemon/graphdriver/zfs/zfs_freebsd.go
@@ -7,8 +7,11 @@ import (
 
 	"github.com/Sirupsen/logrus"
 	"github.com/docker/docker/daemon/graphdriver"
+	zfs "github.com/mistifyio/go-zfs"
 )
 
+var mountOptions = map[string]string{"mountpoint": "legacy"}
+
 func checkRootdirFs(rootdir string) error {
 	var buf syscall.Statfs_t
 	if err := syscall.Statfs(rootdir, &buf); err != nil {
@@ -36,3 +39,36 @@ func getMountpoint(id string) string {
 
 	return id[:maxlen]
 }
+
+// Status returns information about the ZFS filesystem. It returns a two dimensional array of information
+// such as pool name, dataset name, disk usage, parent quota and compression used.
+// Currently it return 'Zpool', 'Zpool Health', 'Parent Dataset', 'Space Used By Parent',
+// 'Space Available', 'Parent Quota' and 'Compression'.
+func (d *Driver) Status() [][2]string {
+	parts := strings.Split(d.dataset.Name, "/")
+	pool, err := zfs.GetZpool(parts[0])
+
+	var poolName, poolHealth string
+	if err == nil {
+		poolName = pool.Name
+		poolHealth = pool.Health
+	} else {
+		poolName = fmt.Sprintf("error while getting pool information %v", err)
+		poolHealth = "not available"
+	}
+
+	quota := "no"
+	if d.dataset.Quota != 0 {
+		quota = strconv.FormatUint(d.dataset.Quota, 10)
+	}
+
+	return [][2]string{
+		{"Zpool", poolName},
+		{"Zpool Health", poolHealth},
+		{"Parent Dataset", d.dataset.Name},
+		{"Space Used By Parent", strconv.FormatUint(d.dataset.Used, 10)},
+		{"Space Available", strconv.FormatUint(d.dataset.Avail, 10)},
+		{"Parent Quota", quota},
+		{"Compression", d.dataset.Compression},
+	}
+}
diff --git a/daemon/graphdriver/zfs/zfs_linux.go b/daemon/graphdriver/zfs/zfs_linux.go
index 52ed516..62f2ca9 100644
--- a/daemon/graphdriver/zfs/zfs_linux.go
+++ b/daemon/graphdriver/zfs/zfs_linux.go
@@ -2,12 +2,16 @@ package zfs
 
 import (
 	"fmt"
+	"strings"
 	"syscall"
 
 	"github.com/Sirupsen/logrus"
 	"github.com/docker/docker/daemon/graphdriver"
+	zfs "github.com/mistifyio/go-zfs"
 )
 
+var mountOptions = map[string]string{"mountpoint": "legacy"}
+
 func checkRootdirFs(rootdir string) error {
 	var buf syscall.Statfs_t
 	if err := syscall.Statfs(rootdir, &buf); err != nil {
@@ -25,3 +29,36 @@ func checkRootdirFs(rootdir string) error {
 func getMountpoint(id string) string {
 	return id
 }
+
+// Status returns information about the ZFS filesystem. It returns a two dimensional array of information
+// such as pool name, dataset name, disk usage, parent quota and compression used.
+// Currently it return 'Zpool', 'Zpool Health', 'Parent Dataset', 'Space Used By Parent',
+// 'Space Available', 'Parent Quota' and 'Compression'.
+func (d *Driver) Status() [][2]string {
+	parts := strings.Split(d.dataset.Name, "/")
+	pool, err := zfs.GetZpool(parts[0])
+
+	var poolName, poolHealth string
+	if err == nil {
+		poolName = pool.Name
+		poolHealth = pool.Health
+	} else {
+		poolName = fmt.Sprintf("error while getting pool information %v", err)
+		poolHealth = "not available"
+	}
+
+	quota := "no"
+	if d.dataset.Quota != 0 {
+		quota = strconv.FormatUint(d.dataset.Quota, 10)
+	}
+
+	return [][2]string{
+		{"Zpool", poolName},
+		{"Zpool Health", poolHealth},
+		{"Parent Dataset", d.dataset.Name},
+		{"Space Used By Parent", strconv.FormatUint(d.dataset.Used, 10)},
+		{"Space Available", strconv.FormatUint(d.dataset.Avail, 10)},
+		{"Parent Quota", quota},
+		{"Compression", d.dataset.Compression},
+	}
+}
